
//-----------------------------RS232 TRANSMIT RUTIN-----------------------
void putch(unsigned char byte) 
{
	/* output one byte */
	while(!TXIF);	/* set when register is empty */
	TXREG = byte;
}

//-----------------------------RS232 RECIEVE RUTIN-----------------------

unsigned char getch(void)
	{
	while(!RCIF);		/*receive interrupt routine*/
	return (RCREG);
	}

//----------------------------BUTTONS RUTIN---------------------------------
void buttons_rutin(){
	if(last_mode != BUTTONS){//display the relevant message on lcd while entering the mode first time
		lcd_clear(); 
        lcd_iwrite(BLINKING_CURSOR_OFF);
        lcd_gotoxy(0,0);
        lcd_puts(buttons_message);
        lcd_gotoxy(0,10);
        lcd_puts(next_message);
		last_mode=BUTTONS;
	}
	if(!SW1)//light relevant led while button preesed
		LED1=0;
	else
		LED1=1;
	if(!SW3)
		LED2=0;
	else
		LED2=1;
	switch(new_press){
		case 'D':
			PORTA=0xff;
			current_mode++;
			new_press=NULL;
		break;
	}
} 
						
//---------------------RUNNING LEDS RUTIN------------------------------------
void leds_rutin(){
	if(last_mode != LEDS){
		lcd_clear(); 
        lcd_gotoxy(0,0);
        lcd_puts(leds_message1);
        lcd_gotoxy(0,10);
        lcd_puts(next_message);
        lcd_gotoxy(1,0);
        lcd_puts(leds_message2);
        last_mode=LEDS;
        direction=LEFT;
	}
	if(leds_flag){
		switch(direction){//check the direction if 1 run the leds left , 2 run the leds right
			case LEFT:
				right_state=0;
				switch(left_state){
					case 0:
						PORTA=0xff;
						RA1=0;														
						left_state=1;
					break;
					case 1:
						PORTA=0xff;
						RA2=0;														
						left_state=2;
					break;
					case 2:
						PORTA=0xff;
						RA3=0;														
						left_state=3;
					break;
					case 3:
						PORTA=0xff;
						RA4=0;														
						left_state=0;
					break;
				}
			break;
		case RIGHT:
				left_state=0;
				switch(right_state){
					case 0:
						PORTA=0xff;
						RA4=0;														
						right_state=1;
					break;
					case 1:
						PORTA=0xff;
						RA3=0;														
						right_state=2;
					break;
					case 2:
						PORTA=0xff;
						RA2=0;														
						right_state=3;
					break;
					case 3:
						PORTA=0xff;
						RA1=0;														
						right_state=0;
					break;
				}
		break;
        }
      leds_flag=0;
     } 
	switch(new_press){
		case 'D':
			PORTA=0xff;
			left_state=0;
			right_state=0;
			current_mode++;
			new_press=NULL;
		break;
		case '1':
			direction=LEFT;
			new_press=NULL;
		break;
		case '2':
			direction=RIGHT;
			new_press=NULL;
		break;
	}
}

//----------------------------BUZZER RUTIN----------------------------------

void buzzer_rutin(){
	if(last_mode != BUZZER){
        lcd_clear();
        lcd_gotoxy(0,0);
        lcd_puts(buzzer_message1);
        lcd_gotoxy(0,10);
        lcd_puts(next_message);
        lcd_gotoxy(1,0);
        lcd_puts(buzzer_message2);
        lcd_gotoxy(1,4); 
		if(PR2 < 100)
			lcd_putch('0');
		lcd_dispnum(PR2);
		lcd_gotoxy(1,13);
		lcd_dispnum(duty_cycle);
        lcd_gotoxy(1,4); 
		cursor_state=4;
        lcd_iwrite(BLINKING_CURSOR_ON);
        last_mode=BUZZER;
		buzzer_state=0;
		CCP1CON=PWM_ON;
	}
	switch(buzzer_state){
		case 0:
			if(new_press >= '0' && new_press <= '2'){
				lcd_putch(new_press);
				lcd_gotoxy(1,cursor_state);
				pr2_digit[0]=new_press-'0';
				new_press=NULL;
			}
			if(new_press == '#'){
				++cursor_state;
				lcd_gotoxy(1,cursor_state);
				new_press=NULL;
				buzzer_state=1;
			}
		break;
		case 1:
			if(pr2_digit[0] < 2){
				if(new_press >= '0' && new_press <= '9'){
					lcd_putch(new_press);
					lcd_gotoxy(1,cursor_state);
					pr2_digit[1]=new_press-'0';
					new_press=NULL;
				}
				if(new_press == '#'){
					++cursor_state;
					lcd_gotoxy(1,cursor_state);
					new_press=NULL;
					buzzer_state=2;
				}
			}
			else{
				if(new_press >= '0' && new_press <= '5'){
					lcd_putch(new_press);
					lcd_gotoxy(1,cursor_state);
					pr2_digit[1]=new_press-'0';
					new_press=NULL;
				}
				if(new_press == '#' && pr2_digit[1] < 6){
					++cursor_state;
					lcd_gotoxy(1,cursor_state);
					new_press=NULL;
					buzzer_state=2;
				}
			}
		break;
		case 2:
			if(pr2_digit[0] == 2 && pr2_digit[1] == 5){
				if(new_press >= '0' && new_press <= '5'){
					lcd_putch(new_press);
					lcd_gotoxy(1,cursor_state);
					pr2_digit[2]=new_press-'0';
					new_press=NULL;
				}
				if(new_press == '#' && pr2_digit[2] < 6){
					cursor_state+=7;
					lcd_gotoxy(1,cursor_state);
					new_press=NULL;
					buzzer_state=3;
				}
			}
			else{
				if(new_press >= '0' && new_press <= '9'){
					lcd_putch(new_press);
					lcd_gotoxy(1,cursor_state);
					pr2_digit[2]=new_press-'0';
					new_press=NULL;
				}
				if(new_press == '#'){
					cursor_state+=7;
					lcd_gotoxy(1,cursor_state);
					new_press=NULL;
					buzzer_state=3;
				}
			}
		break;
		case 3:
			if(new_press >= '0' && new_press <= '9'){
				lcd_putch(new_press);
				lcd_gotoxy(1,cursor_state);
				duty_digit[0]=new_press-'0';
				new_press=NULL;
			}
			if(new_press == '#'){
				++cursor_state;
				lcd_gotoxy(1,cursor_state);
				new_press=NULL;
				buzzer_state=4;
			}
		break;
		case 4:
			if(new_press >= '0' && new_press <= '9'){
				lcd_putch(new_press);
				lcd_gotoxy(1,cursor_state);
				duty_digit[1]=new_press-'0';
				new_press=NULL;
			}
			if(new_press == '#'){
				cursor_state=4;
				lcd_gotoxy(1,cursor_state);
				new_press=NULL;
				buzzer_state=0;
				PR2=pr2_digit[0]*100+pr2_digit[1]*10+pr2_digit[2];
				duty_cycle=duty_digit[0]*10+duty_digit[1];
				CCPR1L=((int)PR2+1)*(int)duty_cycle/100;
			}
		break;
	}
	if(new_press == 'D'){
		CCP1CON=PWM_OFF;
		PR2=99;
		duty_cycle=50;
		pr2_digit[2]=PR2%10;
		pr2_digit[1]=PR2/10;
	    pr2_digit[1]=pr2_digit[1]%10;
	    pr2_digit[0]=PR2/100;
	    duty_digit[1]=duty_cycle%10;
		duty_digit[0]=duty_cycle/10;
        lcd_iwrite(BLINKING_CURSOR_OFF);
		current_mode++;
		new_press=NULL;
	}
}

//------------------DIGITAL TO ANALOG CONVERTER RUTIN------------------------

void d2a_rutin(){
	if(last_mode != D2A){
		ADIE=1;
		ADIF=0;
        lcd_clear();
        lcd_gotoxy(0,0);
        lcd_puts(d2a_message1);
        lcd_gotoxy(0,10);
        lcd_puts(next_message);
        lcd_gotoxy(1,0);
        lcd_puts(d2a_message2);
        lcd_gotoxy(1,3); 
        lcd_iwrite(BLINKING_CURSOR_ON);
        last_mode=D2A;
		cursor_state=3;
	}
	switch(d2a_state){
		case 0:
			if(new_press >= '0' && new_press <= '2'){
				lcd_putch(new_press);
				lcd_gotoxy(1,cursor_state);
				d2a_digit[0]=new_press-'0';
				new_press=NULL;
			}
			if(new_press == '#'){
				cursor_state+=2;
				lcd_gotoxy(1,cursor_state);
				new_press=NULL;
				d2a_state=1;
			}
		break;
		case 1:
			if(d2a_digit[0] < 2){
				if(new_press >= '0' && new_press <= '9'){
					lcd_putch(new_press);
					lcd_gotoxy(1,cursor_state);
					d2a_digit[1]=new_press-'0';
					new_press=NULL;
				}
				if(new_press == '#'){
					++cursor_state;
					lcd_gotoxy(1,cursor_state);
					new_press=NULL;
					d2a_state=2;
				}
			}
			else{
				if(new_press >= '0' && new_press <= '5'){
					lcd_putch(new_press);
					lcd_gotoxy(1,cursor_state);
					d2a_digit[1]=new_press-'0';
					new_press=NULL;
				}
				if(new_press == '#' && d2a_digit[1] < 6){
					++cursor_state;
					lcd_gotoxy(1,cursor_state);
					new_press=NULL;
					d2a_state=2;
				}
			}
		break;
		case 2:
			if(d2a_digit[0] == 2 && d2a_digit[1] == 5){
				if(new_press == '0'){
					lcd_putch(new_press);
					lcd_gotoxy(1,cursor_state);
					d2a_digit[2]=new_press-'0';
					new_press=NULL;
				}
				if(new_press == '#' && d2a_digit[2]==0){
					cursor_state=3;
					lcd_gotoxy(1,cursor_state);
					d2a_value=d2a_digit[0]*100+d2a_digit[1]*10+d2a_digit[2];
					d2a_value=(d2a_value*100)/98;
					write_d2a_data((unsigned char)d2a_value);
					new_press=NULL;
					update_display=1;
					d2a_state=0;
				}
			}
			else{
				if(new_press >= '0' && new_press <= '9'){
					lcd_putch(new_press);
					lcd_gotoxy(1,cursor_state);
					d2a_digit[2]=new_press-'0';
					new_press=NULL;
				}
				if(new_press == '#'){
					cursor_state=3;
					lcd_gotoxy(1,cursor_state);
					d2a_value=d2a_digit[0]*100+d2a_digit[1]*10+d2a_digit[2];
					d2a_value=(d2a_value*100)/98;
					write_d2a_data((unsigned char)d2a_value);
					new_press=NULL;
					update_display=1;
					d2a_state=0;
				}
			}
		break;
	}
	switch(new_press){
		case 'D':
			ADIE=0;
	        update_display=0;
			current_mode++;
			new_press=NULL;
		break;
	}
	if(update_a2d_result_flag){
		a2d_result=(a2d_result*196)/10;
		if(a2d_result % 10 >= 5)
			a2d_result=a2d_result/10+1;
		else	        
			a2d_result=a2d_result/10;
        a2d_flt2=a2d_result%10;
        a2d_flt2+='0';
        a2d_result/=10;
        a2d_flt1=a2d_result%10;
        a2d_flt1+='0';
        a2d_int=(a2d_result/10)+'0';
        lcd_gotoxy(1,11);
        lcd_putch(a2d_int);        
        lcd_putch('.');        
        lcd_putch(a2d_flt1);        
        lcd_putch(a2d_flt2);
        update_a2d_result_flag=0;
 		lcd_gotoxy(1,cursor_state);
	}        
	if(!ADIF)
        ADGO=1;
}	

//-----------------RS232 SERIAL COMMUNICATION RUTIN----------------------

void rs232_rutin(){
	if(last_mode != RS232 && last_mode != USB){
		RCIE=1;
		RCIF=0;
        lcd_clear();
        lcd_gotoxy(0,0);
		if(current_mode == RS232){
	        lcd_puts(rs232_message1);
			last_mode=RS232;
		}
		else{
	        lcd_puts(usb_message1);
			last_mode=USB;
		}
        lcd_gotoxy(0,10);
        lcd_puts(next_message);
        lcd_gotoxy(1,0);
        lcd_puts(rs232_message2);
	}
	switch(rs232_state){
		case 0:
			if(new_press =='1'){
				new_press=NULL;
		        lcd_gotoxy(0,10);
        		lcd_puts(exit_message);
				lcd_clear_2_line();
		        lcd_puts(rs232_message3);
				putch('\f');
				rs232_state=1;
			}
			if(new_press =='2'){
				new_press=NULL;
		        lcd_iwrite(BLINKING_CURSOR_ON);
		        lcd_gotoxy(0,10);
        		lcd_puts(exit_message);
				lcd_clear_2_line();
		        lcd_puts(rs232_message4);
				putch('\f');
				rs232_state=2;
			}
			if(new_press == 'D'){
				new_press=NULL;
				current_mode++;
				last_mode=0;
				first_time=0;
				RCIE=0;
			}
		break;
		case 1:
			if(!first_time){
				lcd_putch('_');
				lcd_gotoxy(1,7);
				first_time=1;
			}
			else if(rs232_value != last_rs232_value){
				last_rs232_value=rs232_value;
				putch('\f');
				putch(last_rs232_value);
				lcd_putch(last_rs232_value);
				lcd_gotoxy(1,7);
			}
			if(new_press == 'D'){
				new_press=NULL;
				first_time=0;
				last_rs232_value='0';
				rs232_value='0';
				rs232_state=0;
		        lcd_clear();
		        lcd_gotoxy(0,0);
				if(current_mode == RS232)
			        lcd_puts(rs232_message1);
				else
			        lcd_puts(usb_message1);
		        lcd_gotoxy(0,10);
		        lcd_puts(next_message);
		        lcd_gotoxy(1,0);
		        lcd_puts(rs232_message2);
			}
		break;
		case 2:
			if(new_press != 'D' && new_press != NULL){
				putch('\f');
				putch(new_press);
				lcd_putch(new_press);
				lcd_gotoxy(1,7);
				new_press=NULL;
			}    	
			if(new_press == 'D'){
				new_press=NULL;
				rs232_state=0;
		        lcd_clear();
		        lcd_gotoxy(0,0);
				if(current_mode == RS232)
			        lcd_puts(rs232_message1);
				else
			        lcd_puts(usb_message1);
		        lcd_gotoxy(0,10);
		        lcd_puts(next_message);
		        lcd_gotoxy(1,0);
		        lcd_puts(rs232_message2);
				putch('\f');
		        lcd_iwrite(BLINKING_CURSOR_OFF);
			}
		break;
	}				 
}	

//-----------------------------EXTERNAL 32KBYTE EEPROM RUTIN--------------

void ext_eeprom_rutin(){
	if(last_mode != EXT_EEPROM){
        lcd_clear();
        lcd_gotoxy(0,0);
        lcd_puts(eeprom_message1);
        lcd_gotoxy(0,10);
        lcd_puts(next_message);
        lcd_gotoxy(1,0);
        lcd_puts(eeprom_message2);
        last_mode=EXT_EEPROM;
	}
	switch(eeprom_state){
		case 0:
			if(new_press =='1'){
				new_press=NULL;
		        lcd_iwrite(BLINKING_CURSOR_ON);
		        lcd_gotoxy(0,10);
        		lcd_puts(exit_message);
				lcd_clear_2_line();
		        lcd_puts(eeprom_message3);
				cursor_state=6;
				lcd_gotoxy(1,cursor_state);
		        lcd_iwrite(BLINKING_CURSOR_ON);
				eeprom_state=1;
			}
			if(new_press =='2'){
				new_press=NULL;
		        lcd_iwrite(BLINKING_CURSOR_ON);
		        lcd_gotoxy(0,10);
        		lcd_puts(exit_message);
				lcd_clear_2_line();
		        lcd_puts(eeprom_message4);
				cursor_state=5;
				lcd_gotoxy(1,cursor_state);
		        lcd_iwrite(BLINKING_CURSOR_ON);
				eeprom_state=2;
			}
			if(new_press == 'D'){
				new_press=NULL;
				current_mode++;
			}
		break;
		case 1:
			switch(store_state){
				case 0:
					if(new_press != NULL && new_press != '#' && new_press != 'D'){
						lcd_putch(new_press);
						lcd_gotoxy(1,cursor_state);
						charecter=new_press;
						new_press=NULL;
					}
					if(new_press == '#'){
						cursor_state=13;
						lcd_gotoxy(1,cursor_state);
						new_press=NULL;
						store_state=1;
					}
				break;
				case 1:
					if(new_press >= '0' && new_press <= '9'){
						lcd_putch(new_press);
						lcd_gotoxy(1,cursor_state);
						add_digit[0]=new_press-'0';
						new_press=NULL;
					}
					if(new_press == '#'){
						++cursor_state;
						lcd_gotoxy(1,cursor_state);
						new_press=NULL;
						store_state=2;
					}
				break;
				case 2:
					if(new_press >= '0' && new_press <= '9'){
						lcd_putch(new_press);
						lcd_gotoxy(1,cursor_state);
						add_digit[1]=new_press-'0';
						new_press=NULL;
					}
					if(new_press == '#'){
						++cursor_state;
						lcd_gotoxy(1,cursor_state);
						new_press=NULL;
						store_state=3;
					}
				break;
				case 3:
					if(new_press >= '0' && new_press <= '9'){
						lcd_putch(new_press);
						lcd_gotoxy(1,cursor_state);
						add_digit[2]=new_press-'0';
						new_press=NULL;
					}
					if(new_press == '#'){
						cursor_state=6;
						address=add_digit[0]*100+add_digit[1]*10+add_digit[2];
                        write_ext_eeprom(address,charecter);
						lcd_gotoxy(1,cursor_state);
						new_press=NULL;
						store_state=0;
					}
				break;
			}
			if(new_press == 'D'){
				new_press=NULL;
				store_state=0;
				eeprom_state=0;
		        lcd_iwrite(BLINKING_CURSOR_OFF);
		        lcd_clear();
		        lcd_gotoxy(0,0);
		        lcd_puts(eeprom_message1);
		        lcd_gotoxy(0,10);
		        lcd_puts(next_message);
		        lcd_gotoxy(1,0);
		        lcd_puts(eeprom_message2);
			}
		break;
		case 2:
			switch(read_state){
				case 0:
					if(new_press >= '0' && new_press <= '9'){
						lcd_putch(new_press);
						lcd_gotoxy(1,cursor_state);
						add_digit[0]=new_press-'0';
						new_press=NULL;
					}
					if(new_press == '#'){
						++cursor_state;
						lcd_gotoxy(1,cursor_state);
						new_press=NULL;
						read_state=1;
					}
				break;
				case 1:
					if(new_press >= '0' && new_press <= '9'){
						lcd_putch(new_press);
						lcd_gotoxy(1,cursor_state);
						add_digit[1]=new_press-'0';
						new_press=NULL;
					}
					if(new_press == '#'){
						++cursor_state;
						lcd_gotoxy(1,cursor_state);
						new_press=NULL;
						read_state=2;
					}
				break;
				case 2:
					if(new_press >= '0' && new_press <= '9'){
						lcd_putch(new_press);
						lcd_gotoxy(1,cursor_state);
						add_digit[2]=new_press-'0';
						new_press=NULL;
					}
					if(new_press == '#'){
						cursor_state=5;
						address=add_digit[0]*100+add_digit[1]*10+add_digit[2];
						charecter=read_ext_eeprom(address);
						lcd_gotoxy(1,15);
						lcd_putch(charecter);
						lcd_gotoxy(1,cursor_state);
						new_press=NULL;
						read_state=0;
					}
				break;
			}			
			if(new_press == 'D'){
				new_press=NULL;
		        lcd_iwrite(BLINKING_CURSOR_OFF);
				read_state=0;
				eeprom_state=0;
		        lcd_clear();
		        lcd_gotoxy(0,0);
		        lcd_puts(eeprom_message1);
		        lcd_gotoxy(0,10);
		        lcd_puts(next_message);
		        lcd_gotoxy(1,0);
		        lcd_puts(eeprom_message2);
			}
		break;
	}				 
}

//-----------------------ANALOG TO DIGITAL CONVERTER CHANNEL SELECT----

void select_a2d_channel(unsigned char channel)
{
	ADCON0 = (channel << 3) | 0x41;		
}


//---------------------ANALOG TO DIGITAL RUTIN------------------------

void a2d_rutin(){
	if(last_mode != A2D){
        ADIF=0;
        ADIE=1;
        lcd_iwrite(BLINKING_CURSOR_OFF);
        lcd_clear();
        lcd_gotoxy(0,0);
        lcd_puts(a2d_message1);
        lcd_gotoxy(0,10);
        lcd_puts(next_message);
        lcd_gotoxy(1,5);
        lcd_puts(a2d_message2);
        last_mode=A2D;
	}
	if(update_a2d_result_flag){
		a2d_result=(a2d_result*196)/10;        
		if(a2d_result % 10 >= 5)
			a2d_result=a2d_result/10+1;
		else	        
			a2d_result=a2d_result/10;
        a2d_flt2=a2d_result%10;
        a2d_flt2+='0';
        a2d_result/=10;
        a2d_flt1=a2d_result%10;
        a2d_flt1+='0';
        a2d_int=(a2d_result/10)+'0';
        lcd_gotoxy(1,5);
        lcd_putch(a2d_int);        
        lcd_putch('.');        
        lcd_putch(a2d_flt1);        
        lcd_putch(a2d_flt2);
        update_a2d_result_flag=0;
	}        
	if(!ADIF)
        ADGO=1;
	switch(new_press){
		case 'D':
			ADIE=0;
	        update_a2d_result_flag=0;
			current_mode++;
			new_press=NULL;
		break;
	}
}

//-------------RF RUTIN (WITH RS232 PROTOCOL)-----------------


void rf_rutin(){
	if(last_mode != RF){
		RCIE=1;
		RCIF=0;
		BRGH=0;
		SPBRG=207;
        lcd_iwrite(BLINKING_CURSOR_ON);
        lcd_clear();
        lcd_gotoxy(0,0);
        lcd_puts(rf_message1);
        lcd_gotoxy(0,10);
        lcd_puts(next_message);
        lcd_gotoxy(1,0);
        lcd_puts(rf_message2);
        last_mode=RF;
		lcd_gotoxy(1,7);
	}
	if(new_press != 'D' && new_press != NULL){
		putch(new_press);
		lcd_putch(new_press);
		lcd_gotoxy(1,7);
		new_press=NULL;
	}    	
	if(rs232_value != last_rs232_value){
		last_rs232_value=rs232_value;
		lcd_gotoxy(1,15);
		lcd_putch(last_rs232_value);
		lcd_gotoxy(1,7);
	}
	if(new_press == 'D'){
		new_press=NULL;
		RCIE=0;
		BRGH=1;
		SPBRG=51;
		current_mode=LEDS;
        lcd_iwrite(BLINKING_CURSOR_OFF);
	}
}
