#define ON       1
#define OFF      0
#define MASTER_MODE  	 0x08  // 7 bit address i2c master mode


void i2c_init ()
{
SSPEN=ON;
TRISC3=ON;
TRISC4=ON;
STAT_CKE=OFF;
STAT_SMP=OFF;
SSPADD=9;  //9
SSPCON|=MASTER_MODE;
SSPCON2=0;
}

void write_ext_eeprom ( int address,unsigned char data )
{
unsigned char addressh,addressl;
//
addressl=(address & 0x00ff);
addressh=(address >> 8);
//
SEN=ON; // start condition
while (!SSPIF);
SSPIF=0;
//
SSPBUF=0xa8; //control byte
while (!SSPIF);
SSPIF=0;
//
SSPBUF=addressh; //address byte
while (!SSPIF);
SSPIF=0;
//
SSPBUF=addressl; //address byte
while (!SSPIF);
SSPIF=0;
//
SSPBUF=data; // data byte
while (!SSPIF);
SSPIF=0;
//
PEN=ON;        // stop condition
while (!SSPIF);
SSPIF=0;
//
DelayMs (10);
}

unsigned char read_ext_eeprom (int address)
{
unsigned char addressh,addressl;
//
addressl=(address & 0x00ff);
addressh=(address >> 8);
//
SEN=ON; // start condition
while (!SSPIF);
SSPIF=0;
//
SSPBUF=0xa8; //control byte
while (!SSPIF);
SSPIF=0;//
//
SSPBUF=addressh; //address byte
while (!SSPIF);
SSPIF=0;
//
SSPBUF=addressl; //address byte
while (!SSPIF);
SSPIF=0;
//
RSEN=ON; // start condition
while (!SSPIF);
SSPIF=0;
//
SSPBUF=0xa9; //control byte
while (!SSPIF);
SSPIF=0;//
//
RCEN=1;
while (!SSPIF);
SSPIF=0;//
//
PEN=ON;        // stop condition
while (!SSPIF);
SSPIF=0;
//
return (SSPBUF);
}
